/* de21du.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b25 = 10.;

/* Subroutine */ int de21du_c(doublereal *a, doublereal *lu, integer *n,
        integer *ia, integer *ndig, doublereal *d1, doublereal *d2, 
        doublereal *ipvt, doublereal *equil, doublereal *wa, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;
    static doublereal one = 1.;
    static doublereal four = 4.;
    static doublereal sixtn = 16.;
    static doublereal sixth = .0625;

    /* System generated locals */
    integer a_dim1, a_offset, lu_dim1, lu_offset, i__1, i__2, i__3;

    /* Builtin functions */
    double pow_di(doublereal *, integer *);

    /* Local variables */
    static doublereal biga;
    static integer idgt, imax;
    static doublereal wrel, test;
    static integer i__, j, k;
    static doublereal p, q, t, ai, rn, wi;
    static integer im1, jm1, jp1;
    static doublereal big, sum;

#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define lu_ref(a_1,a_2) lu[(a_2)*lu_dim1 + a_1]

    /* Parameter adjustments */
    lu_dim1 = *ia;
    lu_offset = 1 + lu_dim1 * 1;
    lu -= lu_offset;
    a_dim1 = *ia;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --ipvt;
    --equil;

    /* Function Body */
    idgt = *ndig;
    *ierr = 0;
    rn = (doublereal) (*n);
    wrel = zero;
    *d1 = one;
    *d2 = zero;
    biga = zero;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        big = zero;
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            p = a_ref(i__, j);
            lu_ref(i__, j) = p;
            p = abs(p);
            if (p > big) {
                big = p;
            }
/* L1: */
        }
        if (big > biga) {
            biga = big;
        }
        if (big == zero) {
            goto L22;
        }
        equil[i__] = one / big;
/* L2: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        jm1 = j - 1;
        if (jm1 < 1) {
            goto L8;
        }
        i__2 = jm1;
        for (i__ = 1; i__ <= i__2; ++i__) {
            sum = lu_ref(i__, j);
            im1 = i__ - 1;
            if (idgt == 0) {
                goto L5;
            }
            ai = abs(sum);
            wi = zero;
            if (im1 < 1) {
                goto L4;
            }
            i__3 = im1;
            for (k = 1; k <= i__3; ++k) {
                t = lu_ref(i__, k) * lu_ref(k, j);
                sum -= t;
                wi += abs(t);
/* L3: */
            }
            lu_ref(i__, j) = sum;
L4:
            wi += abs(sum);
            if (ai == zero) {
                ai = biga;
            }
            test = wi / ai;
            if (test > wrel) {
                wrel = test;
            }
            goto L7;
L5:
            if (im1 < 1) {
                goto L7;
            }
            i__3 = im1;
            for (k = 1; k <= i__3; ++k) {
                sum -= lu_ref(i__, k) * lu_ref(k, j);
/* L6: */
            }
            lu_ref(i__, j) = sum;
L7:
            ;
        }
L8:
        p = zero;
        i__2 = *n;
        for (i__ = j; i__ <= i__2; ++i__) {
            sum = lu_ref(i__, j);
            if (idgt == 0) {
                goto L11;
            }
            ai = abs(sum);
            wi = zero;
            if (jm1 < 1) {
                goto L10;
            }
            i__3 = jm1;
            for (k = 1; k <= i__3; ++k) {
                t = lu_ref(i__, k) * lu_ref(k, j);
                sum -= t;
                wi += abs(t);
/* L9: */
            }
            lu_ref(i__, j) = sum;
L10:
            wi += abs(sum);
            if (ai == zero) {
                ai = biga;
            }
            test = wi / ai;
            if (test > wrel) {
                wrel = test;
            }
            goto L13;
L11:
            if (jm1 < 1) {
                goto L13;
            }
            i__3 = jm1;
            for (k = 1; k <= i__3; ++k) {
                sum -= lu_ref(i__, k) * lu_ref(k, j);
/* L12: */
            }
            lu_ref(i__, j) = sum;
L13:
            q = equil[i__] * abs(sum);
            if (p >= q) {
                goto L14;
            }
            p = q;
            imax = i__;
L14:
            ;
        }
        if (rn + p == rn) {
            goto L22;
        }
        if (j == imax) {
            goto L16;
        }
        *d1 = -(*d1);
        i__2 = *n;
        for (k = 1; k <= i__2; ++k) {
            p = lu_ref(imax, k);
            lu_ref(imax, k) = lu_ref(j, k);
            lu_ref(j, k) = p;
/* L15: */
        }
        equil[imax] = equil[j];
L16:
        ipvt[j] = (doublereal) imax;
        *d1 *= lu_ref(j, j);
L17:
        if (abs(*d1) <= one) {
            goto L18;
        }
        *d1 *= sixth;
        *d2 += four;
        goto L17;
L18:
        if (abs(*d1) >= sixth) {
            goto L19;
        }
        *d1 *= sixtn;
        *d2 -= four;
        goto L18;
L19:
        jp1 = j + 1;
        if (jp1 > *n) {
            goto L21;
        }
        p = lu_ref(j, j);
        i__2 = *n;
        for (i__ = jp1; i__ <= i__2; ++i__) {
            lu_ref(i__, j) = lu_ref(i__, j) / p;
/* L20: */
        }
L21:
        ;
    }
    if (idgt == 0) {
        goto L24;
    }
    p = (doublereal) (*n * 3 + 3);
    *wa = p * wrel;
    i__1 = -idgt;
    if (*wa + pow_di(&c_b25, &i__1) != *wa) {
        goto L24;
    }
    *ierr = 66;
    goto L23;
L22:
    *ierr = 65;
    *d1 = zero;
    *d2 = zero;
L23:
L24:
    return 0;
} /* de21du_c */

#undef lu_ref
#undef a_ref
